package com.huimv.eartag2.manage2.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.manage2.mapper.BasePigpenMapper;
import com.huimv.eartag2.manage2.pojo.BaseFarm;
import com.huimv.eartag2.manage2.pojo.BasePigpen;
import com.huimv.eartag2.manage2.pojo.EartagDeviceRegister;
import com.huimv.eartag2.manage2.mapper.EartagDeviceRegisterMapper;
import com.huimv.eartag2.manage2.service.EartagDeviceRegisterService;
import com.huimv.eartag2.manage2.service.IEartagDeviceRegisterService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.eartag2.manage2.utils.IDUtil;
import com.huimv.eartag2.manage2.utils.ResultUtil;
import com.huimv.eartag2.manage2.vo.EartagDeviceRegisterVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-07-20
 */
@Service
public class EartagDeviceRegisterServiceImpl extends ServiceImpl<EartagDeviceRegisterMapper, EartagDeviceRegister> implements EartagDeviceRegisterService {

    @Resource
    private EartagDeviceRegisterMapper eartagDeviceRegisterMapper;

    @Resource
    private BasePigpenMapper basePigpenMapper;

    @Autowired
    private ResultUtil resultUtil;

    @Autowired
    private IDUtil idUtil;



    @Override
    public Result set(List<Map<String, String>> mapList) {
        ArrayList<Integer> ids = new ArrayList<>();
        for (Map<String, String> map : mapList) {
            String id = map.get("id");
            ids.add(Integer.valueOf(id));
        }
        String pigpenId = mapList.get(0).get("pigpenId");
        String unitId = mapList.get(0).get("unitId");

       //查询栋舍和单元放入位置字段
       List<EartagDeviceRegister> eartagDeviceRegister = eartagDeviceRegisterMapper.selectBatchIds(ids);
        for (EartagDeviceRegister deviceRegister : eartagDeviceRegister) {
            deviceRegister.setPigpenId(Integer.valueOf(pigpenId));
            deviceRegister.setChipId(unitId);
        }
        //批量更新
        UpdateWrapper<EartagDeviceRegister> updateWrapper = new UpdateWrapper<>();
        updateWrapper.lambda().in(EartagDeviceRegister::getUnitId,ids);
        EartagDeviceRegister eartagDeviceRegister1 = new EartagDeviceRegister();
        eartagDeviceRegister1.setPigpenId(Integer.valueOf(pigpenId));
        eartagDeviceRegister1.setUnitId(Integer.valueOf(unitId));

        return resultUtil.result(eartagDeviceRegisterMapper.update(eartagDeviceRegister1,updateWrapper));
    }

    @Override
    public Result remove(String ids) {
        List<Integer> convert = idUtil.convert(ids);
        return resultUtil.result(eartagDeviceRegisterMapper.deleteBatchIds(convert));
    }

    @Override
    public Result update(Map<String, String> maps) {
        String id = maps.get("id");
        String pigpenId = maps.get("pigpenId");
        String unitId = maps.get("unitId");

        String chipId = maps.get("chipId");
        String deviceCode = maps.get("deviceCode");
        String deviceAlias = maps.get("deviceAlias");
        String activeStatus = maps.get("activeStatus");
        String deviceStatus = maps.get("deviceStatus");

        String remark = maps.get("remark");
        EartagDeviceRegister eartagDeviceRegister = eartagDeviceRegisterMapper.selectById(id);
        eartagDeviceRegister.setPigpenId(Integer.valueOf(pigpenId));
        eartagDeviceRegister.setUnitId(Integer.valueOf(unitId));
        eartagDeviceRegister.setChipId(chipId);
        eartagDeviceRegister.setDeviceAlias(deviceAlias);
        eartagDeviceRegister.setDeviceCode(deviceCode);
        eartagDeviceRegister.setActiveStatus(Integer.valueOf(activeStatus));
        eartagDeviceRegister.setRemark(remark);
        eartagDeviceRegister.setDeviceStatus(Integer.valueOf(deviceStatus));
        return resultUtil.result(eartagDeviceRegisterMapper.updateById(eartagDeviceRegister));
    }

    @Override
    public Result list(Map<String, String> paramsMap) {


        EartagDeviceRegisterVo eartagDeviceRegisterVo = new EartagDeviceRegisterVo();

        return null;
    }

    @Override
    public Result add(Map<String, String> mapList) {
        String pigpenId = mapList.get("pigpenId");
        String unitId = mapList.get("unitId");

        String chipId = mapList.get("chipId");
        String deviceCode = mapList.get("deviceCode");
        String deviceAlias = mapList.get("deviceAlias");
        String activeStatus = mapList.get("activeStatus");
        String deviceStatus = mapList.get("deviceStatus");
        String remark = mapList.get("remark");

        EartagDeviceRegister eartagDeviceRegister = new EartagDeviceRegister();
        eartagDeviceRegister.setPigpenId(Integer.valueOf(pigpenId));
        eartagDeviceRegister.setUnitId(Integer.valueOf(unitId));
        eartagDeviceRegister.setChipId(chipId);
        eartagDeviceRegister.setDeviceAlias(deviceAlias);
        eartagDeviceRegister.setDeviceCode(deviceCode);
        eartagDeviceRegister.setActiveStatus(Integer.valueOf(activeStatus));
        eartagDeviceRegister.setRemark(remark);
        eartagDeviceRegister.setDeviceStatus(Integer.valueOf(deviceStatus));
        return resultUtil.result(eartagDeviceRegisterMapper.insert(eartagDeviceRegister));
    }

    @Override
    public Result cancel() {
        return null;
    }
}
